## cloudcompare 2.10.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

cmake_policy(PUSH)

project( CloudCompareProjects )

option(BUILD_TESTING "" OFF)
include(CTest)

include( cmake/CMakePolicies.cmake )
include( cmake/CMakeSetCompilerOptions.cmake )

# Default debug suffix for libraries.
set( CMAKE_DEBUG_POSTFIX "d" )

# One shouldn't generate the BUILD project directly in the SOURCES folder!
if ( ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR} )
	if ( NOT SAME_BUILD_AND_SOURCE_FOLDER_WARNING_ALREADY_ISSUED )
		message(FATAL_ERROR "It is not advised to BUILD the binaries directly in the SOURCE folder!\n If you want to proceed with this option, just CONFIGURE the project once again" )
		set( SAME_BUILD_AND_SOURCE_FOLDER_WARNING_ALREADY_ISSUED TRUE )
	endif()
endif()

# Default install folders
# (on Windows - msvc generator - the '_debug' suffix is automatically added for debug configurations)
set( INSTALL_DESTINATIONS CloudCompare )

# RPATH Linux/Unix: (dynamic) libs are put in a subdir of prefix/lib,
# since they are only used by qCC/ccViewer
if( UNIX AND NOT APPLE )
	if( NOT CMAKE_INSTALL_LIBDIR )
		set( CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_PREFIX}/lib CACHE PATH "CloudCompare lib dir" )
	endif( NOT CMAKE_INSTALL_LIBDIR )
	set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_LIBDIR}/cloudcompare")
endif()

# CCViewer
OPTION( OPTION_BUILD_CCVIEWER "Check to compile CCViewer project" ON )

# Quad buffer stereo support
OPTION( OPTION_GL_QUAD_BUFFER_SUPPORT "Check to compile CloudCompare and ccViewer with Quad Buffer support" OFF )

# Define target folders
# (now that ccViewer can have its own plugins, qCC and ccViewer must fall in separate folders!
if(WIN32 OR APPLE) 
	set( CLOUDCOMPARE_DEST_FOLDER CloudCompare )
	set( CCVIEWER_DEST_FOLDER ccViewer )
	if (OPTION_GL_QUAD_BUFFER_SUPPORT)
		set ( CLOUDCOMPARE_DEST_FOLDER ${CLOUDCOMPARE_DEST_FOLDER}Stereo )
		set ( CCVIEWER_DEST_FOLDER ${CCVIEWER_DEST_FOLDER}Stereo )
	endif()
else()
	set( CLOUDCOMPARE_DEST_FOLDER bin )
	set( CCVIEWER_DEST_FOLDER bin )
endif()

if (APPLE)
	set( CLOUDCOMPARE_MAC_BASE_DIR ${CMAKE_INSTALL_PREFIX}/${CLOUDCOMPARE_DEST_FOLDER}/CloudCompare.app  CACHE INTERNAL "CloudCompare bundle dir")
	set( CLOUDCOMPARE_MAC_FRAMEWORK_DIR ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Frameworks CACHE INTERNAL "CC framework dir" )
	set( CLOUDCOMPARE_MAC_PLUGIN_DIR ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/PlugIns/ccPlugins CACHE INTERNAL "CC plugin dir" )
	
	set( CCVIEWER_MAC_BASE_DIR ${CMAKE_INSTALL_PREFIX}/${CCVIEWER_DEST_FOLDER}/ccViewer.app CACHE INTERNAL "ccViewer bundle dir")
	set( CCVIEWER_MAC_FRAMEWORK_DIR ${CCVIEWER_MAC_BASE_DIR}/Contents/Frameworks CACHE INTERNAL "CCViewer framework dir" )
	set( CCVIEWER_MAC_PLUGIN_DIR ${CCVIEWER_MAC_BASE_DIR}/Contents/PlugIns/ccPlugins CACHE INTERNAL "CCViewer plugin dir" )
endif()

# set default install folders
if( WIN32 )
    # (on Windows - msvc generator - the '_debug' suffix is automatically added for debug configurations)
    set( INSTALL_DESTINATIONS ${CLOUDCOMPARE_DEST_FOLDER} )
    
    if( ${OPTION_BUILD_CCVIEWER} )
        list( APPEND INSTALL_DESTINATIONS ${CCVIEWER_DEST_FOLDER} )
    endif()
elseif( APPLE )
	set( INSTALL_DESTINATIONS "${CLOUDCOMPARE_MAC_FRAMEWORK_DIR}" )
    
    if( ${OPTION_BUILD_CCVIEWER} )
        list( APPEND INSTALL_DESTINATIONS "${CCVIEWER_MAC_FRAMEWORK_DIR}" )
    endif()
elseif( UNIX )
	set( INSTALL_DESTINATIONS ${CMAKE_INSTALL_PREFIX}/bin )
endif()

# Load advanced scripts
include( cmake/CMakeInclude.cmake )

add_subdirectory( CC )

# Add external libraries
include( cmake/CMakeExternalLibs.cmake )

# Contrib. libraries (mainly for I/O)
include( contrib/AllSupport.cmake )

# Libs requested by both qCC & ccViewer
add_subdirectory( libs/CCFbo )
add_subdirectory( libs/qCC_db ) # must always be included after CCFbo (dependency)
add_subdirectory( libs/qCC_io ) # must always be included after qCC_db (dependency)
add_subdirectory( libs/qCC_glWindow ) # must always be included after qCC_db (dependency)
add_subdirectory( libs/qcustomplot )

# load plugins (potentially used by qCC and ccViewer)
add_subdirectory( plugins )

# qCC
add_subdirectory( qCC )

# CCViewer
if( ${OPTION_BUILD_CCVIEWER} )
	add_subdirectory( ccViewer )
endif()

cmake_policy(POP)

=== CC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

cmake_policy(PUSH)

# Options
option( COMPILE_CC_CORE_LIB_WITH_QT "Check to compile CC_CORE_LIB with Qt (to enable parallel processing)" ON )
option( COMPILE_CC_CORE_LIB_WITH_CGAL "Check to compile CC_CORE_LIB with CGAL lib. (to enable Delaunay 2.5D triangulation with a GPL compliant licence)" OFF )
option( COMPILE_CC_CORE_LIB_WITH_TBB " Check to compile CC_CORE_LIB with Intel Threading Building Blocks lib (enables some parallel processing )" OFF )
option( COMPILE_CC_CORE_LIB_SHARED "Check to compile CC_CORE_LIB as a shared library (DLL/so)" ON )

# to compile CCLib only! (CMake implicitly imposes to declare a project before anything...)
project( CC_CORE_LIB VERSION 1.0 )

include ( ../cmake/CMakePolicies.cmake )
include ( ../cmake/CMakeSetCompilerOptions.cmake )

# CGAL takes precedence over triangle
if (COMPILE_CC_CORE_LIB_WITH_CGAL)
	include( cmake/CGALSupport.cmake )
endif()

if (COMPILE_CC_CORE_LIB_WITH_TBB)
	include( cmake/FindTBB.cmake )
else()
	if (NOT WIN32)
		message( WARNING "CCLib configured without parallel algorithm capabilities - see COMPILE_CC_CORE_LIB_WITH_TBB" )
	endif()
endif()

# Additional dependencies (only Qt in fact)
if (COMPILE_CC_CORE_LIB_WITH_QT)
	include( ../cmake/CMakeExternalLibs.cmake )
endif()

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/include )

file( GLOB header_list include/*.h)
file( GLOB source_list src/*.cpp src/*.h)

if (COMPILE_CC_CORE_LIB_SHARED)
	add_library( ${PROJECT_NAME} SHARED ${header_list} ${source_list} )
else()
	add_library( ${PROJECT_NAME} STATIC ${header_list} ${source_list} )
endif()

if (COMPILE_CC_CORE_LIB_WITH_CGAL)
	target_link_libraries( ${PROJECT_NAME} ${CGAL_LIBRARIES} )
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS USE_CGAL_LIB )
endif()

if (COMPILE_CC_CORE_LIB_WITH_TBB)
	include_directories( ${TBB_INCLUDE_DIRS} )
	target_link_libraries( ${PROJECT_NAME} ${TBB_LIBRARIES} )
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS USE_TBB )
endif()

if ( COMPILE_CC_CORE_LIB_WITH_QT )
	include_directories( ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} )
	target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Widgets Qt5::Concurrent)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS USE_QT )
endif()

# Load advanced scripts
include( ../cmake/CMakeInclude.cmake )

if ( COMPILE_CC_CORE_LIB_SHARED )
	if (WIN32)
		set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_USE_AS_DLL )
	endif()

	# Install (shared) library to specified destinations
	if( WIN32 OR APPLE )
		foreach( dest ${INSTALL_DESTINATIONS} )
			install_shared( CC_CORE_LIB ${dest} 1 )
		endforeach()
	else()
		install_shared( CC_CORE_LIB ${CMAKE_INSTALL_LIBDIR}/cloudcompare 0 ) #default destination: /usr/lib/cloudcompare
	endif()
endif()

if (WIN32)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS _CRT_SECURE_NO_WARNINGS )
endif()

set( CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DCC_DEBUG" )
set( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DCC_DEBUG" )

cmake_policy(POP)

=== ccViewer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project( ccViewer VERSION 1.38.0 )

include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )
include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${QCC_DB_LIB_SOURCE_DIR} )
if( MSVC )
   include_directories( ${QCC_DB_LIB_SOURCE_DIR}/msvc )
endif()
include_directories( ${QCC_IO_LIB_SOURCE_DIR} )
include_directories( ${QCC_GL_LIB_SOURCE_DIR} )
include_directories( ${CloudComparePlugins_SOURCE_DIR} )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../common )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../qCC )
include_directories( ${CMAKE_CURRENT_BINARY_DIR} )

file( GLOB header_list *.h )
file( GLOB source_list *.cpp )

file( GLOB ui_list ui_templates/*.ui )
file( GLOB qrc_list ../qCC/*.qrc )
file( GLOB rc_list ../qCC/*.rc )

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../common ${CMAKE_CURRENT_BINARY_DIR}/common)

# 3DX support (3dConnexion devices)
if ( ${OPTION_SUPPORT_3DCONNEXION_DEVICES} )
	add_subdirectory( ../qCC/devices/3dConnexion devices/3dConnexion )
endif()

# Gamepad support (requires Qt 5.7+)
if ( ${OPTION_SUPPORT_GAMEPADS} )
	add_subdirectory( ../qCC/devices/gamepad devices/gamepad )
endif()

qt5_wrap_ui( generated_ui_list ${ui_list} )
qt5_add_resources( generated_qrc_list ${qrc_list} )

if( MSVC )
	# App icon with MSVC
	set( rc_list images/icon/cc_viewer_icon.rc )

	#to get rid of the (system) console
	add_executable( ${PROJECT_NAME} WIN32 ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list})
elseif( APPLE )
	add_executable( ${PROJECT_NAME} MACOSX_BUNDLE ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list})
else()
	add_executable( ${PROJECT_NAME} ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list})
endif()

target_link_libraries( ${PROJECT_NAME} CC_FBO_LIB )
target_link_libraries( ${PROJECT_NAME} CC_CORE_LIB )
target_link_libraries( ${PROJECT_NAME} QCC_DB_LIB )
target_link_libraries( ${PROJECT_NAME} QCC_IO_LIB )
target_link_libraries( ${PROJECT_NAME} QCC_GL_LIB )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui Qt5::Widgets Qt5::OpenGL)
if (WIN32)
	target_link_libraries( ${PROJECT_NAME} Qt5::WinMain )
endif()

# contrib. libraries support
if ( APPLE )
	target_link_contrib( ${PROJECT_NAME} ${CLOUDCOMPARE_MAC_FRAMEWORK_DIR} )
elseif( UNIX )
	target_link_contrib( ${PROJECT_NAME} ${CMAKE_INSTALL_LIBDIR}/cloudcompare )
else()
	target_link_contrib( ${PROJECT_NAME} ${CCVIEWER_DEST_FOLDER} )
endif()

# 3dConnexion devices support
if ( ${OPTION_SUPPORT_3DCONNEXION_DEVICES} )
	target_link_3DXWARE( ${PROJECT_NAME} )
endif()

# Gamepad support (requires Qt 5.7+)
if ( ${OPTION_SUPPORT_GAMEPADS} )
	target_link_GAMEPADS( ${PROJECT_NAME} )
endif()

# Add custom preprocessor definitions
set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_VIEWER )
if (OPTION_GL_QUAD_BUFFER_SUPPORT)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_GL_WINDOW_USE_QWINDOW )
endif()
if (WIN32)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_USE_AS_DLL QCC_DB_USE_AS_DLL QCC_IO_USE_AS_DLL )
	if (MSVC)
		SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES LINK_FLAGS " /MANIFEST:NO")
	endif()
endif()

# App icon with Code::Blocks/MinGW
if( WIN32 )
	if( MINGW )
		add_custom_command( TARGET ${PROJECT_NAME} PRE_BUILD COMMAND ${CMAKE_RC_COMPILER} -i ${CMAKE_CURRENT_SOURCE_DIR}/images/icon/cc_viewer_icon.rc --input-format=rc -o ${CMAKE_CURRENT_BINARY_DIR}/ccViewer.res -O coff )
	endif()
endif()

# install program
install_ext( TARGETS ccViewer ${CCVIEWER_DEST_FOLDER} )

# Auxiliary files
set( auxFiles bin_other/license.txt )

if( WIN32 )
	# Export Qt dlls
	install_Qt_Dlls( ${CCVIEWER_DEST_FOLDER} ${OPTION_SUPPORT_GAMEPADS} )
	install_Qt5_plugins( ${CCVIEWER_DEST_FOLDER} )

	# Additional auxiliary file(s)
	list( APPEND auxFiles bin_other/start.bat )
endif()

# Install auxiliary files
if(APPLE OR WIN32) # For Linux it's already installed in by qCC
	foreach( filename ${auxFiles} )
		install_ext( FILES ${filename} ${CCVIEWER_DEST_FOLDER} )
	endforeach()
endif()

# Put together our App bundle on Mac OS X
if( APPLE )
	set_target_properties( ${PROJECT_NAME} PROPERTIES
		INSTALL_RPATH "@executable_path/../Frameworks"
		MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Mac/ccViewer.plist )

	set( MACOSX_BUNDLE_ICON_FILE cc_viewer_icon.icns )
	set( MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}" )
	set( MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_VERSION}" )
	set( MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_VERSION}" )

	add_subdirectory( Mac )
endif( APPLE )

# Export common shader files to all install destinations
if( APPLE )
	install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/../qCC/shaders/ColorRamp/color_ramp.frag DESTINATION ${CCVIEWER_MAC_BASE_DIR}/Contents/Shaders/ColorRamp )
elseif( WIN32 ) # For Linux it's already installed in by qCC
	install_ext( FILES ${CMAKE_CURRENT_SOURCE_DIR}/../qCC/shaders/ColorRamp/color_ramp.frag ${CCVIEWER_DEST_FOLDER} /shaders/ColorRamp )
endif()

=== qCC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project( CloudCompare VERSION 2.10.1 )

include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )
include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${QCC_DB_LIB_SOURCE_DIR} )
if( MSVC )
   include_directories( ${QCC_DB_LIB_SOURCE_DIR}/msvc )
endif()
include_directories( ${QCC_IO_LIB_SOURCE_DIR} )
include_directories( ${QCC_GL_LIB_SOURCE_DIR} )
include_directories( ${CloudComparePlugins_SOURCE_DIR} )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../common )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/db_tree )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/ui_templates )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../libs/qcustomplot )
include_directories( ${CMAKE_CURRENT_BINARY_DIR} )

file( GLOB header_list *.h  )
file( GLOB source_list *.cpp )

file( GLOB ui_list ui_templates/*.ui )
file( GLOB qrc_list *.qrc )

file( GLOB txt_list TODO.txt ${CloudCompareProjects_SOURCE_DIR}/CHANGELOG.md )

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../common ${CMAKE_CURRENT_BINARY_DIR}/common)
add_subdirectory( db_tree )
add_subdirectory( pluginManager )

# 3DX support (3dConnexion devices)
if ( ${OPTION_SUPPORT_3DCONNEXION_DEVICES} )
	add_subdirectory( devices/3dConnexion )
endif()	

# Gamepad support (requires Qt 5.7+)
if ( ${OPTION_SUPPORT_GAMEPADS} )
	add_subdirectory( devices/gamepad )
endif()	

qt5_wrap_ui( generated_ui_list ${ui_list} )
qt5_add_resources( generated_qrc_list ${qrc_list} )

if( MSVC )
	# App icon with MSVC
	set( rc_list images/icon/cc_icon.rc )

	#to get rid of the (system) console
	add_executable( ${PROJECT_NAME} WIN32 ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list} ${txt_list} )
elseif( APPLE )
	add_executable( ${PROJECT_NAME} MACOSX_BUNDLE ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${txt_list} )
else()
	add_executable( ${PROJECT_NAME} ${header_list} ${source_list} ${generated_ui_list} ${generated_qrc_list} ${rc_list} ${txt_list} )
endif()

target_link_libraries( ${PROJECT_NAME} CC_FBO_LIB )
target_link_libraries( ${PROJECT_NAME} CC_CORE_LIB )
target_link_libraries( ${PROJECT_NAME} QCC_DB_LIB )
target_link_libraries( ${PROJECT_NAME} QCC_IO_LIB )
target_link_libraries( ${PROJECT_NAME} QCC_GL_LIB )
target_link_libraries( ${PROJECT_NAME} qcustomplot )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui Qt5::Widgets Qt5::OpenGL Qt5::PrintSupport)
if (WIN32)
	target_link_libraries( ${PROJECT_NAME} Qt5::WinMain )
endif()

# contrib. libraries support
if( APPLE )
	target_link_contrib( ${PROJECT_NAME} ${CLOUDCOMPARE_MAC_FRAMEWORK_DIR} )
elseif( UNIX )
	target_link_contrib( ${PROJECT_NAME} lib/cloudcompare )
else()
	target_link_contrib( ${PROJECT_NAME} ${CLOUDCOMPARE_DEST_FOLDER} )
endif()

# 3dConnexion devices support
if ( ${OPTION_SUPPORT_3DCONNEXION_DEVICES} )
	target_link_3DXWARE( ${PROJECT_NAME} )
endif()
# Gamepad support (requires Qt 5.7+)
if ( ${OPTION_SUPPORT_GAMEPADS} )
	target_link_GAMEPADS( ${PROJECT_NAME} )
endif()

# Add custom preprocessor definitions
if (OPTION_GL_QUAD_BUFFER_SUPPORT)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_GL_WINDOW_USE_QWINDOW )
endif()
if( WIN32 )
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_USE_AS_DLL QCC_DB_USE_AS_DLL QCC_IO_USE_AS_DLL )
	if (MSVC)
		SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES LINK_FLAGS " /MANIFEST:NO")
	endif()
endif()

# App icon with Code::Blocks/MinGW
if( WIN32 )
	if( MINGW )
		if (NOT CMAKE_RC_COMPILER)
			set( CMAKE_RC_COMPILER windres )
		endif()
		add_custom_command( TARGET ${PROJECT_NAME} PRE_BUILD COMMAND ${CMAKE_RC_COMPILER} -i ${CMAKE_CURRENT_SOURCE_DIR}/images/icon/cc_icon.rc --input-format=rc -o ${CMAKE_CURRENT_BINARY_DIR}/cc_icon.res -O coff )
	endif()
endif()

# install program
install_ext( TARGETS ${PROJECT_NAME} ${CLOUDCOMPARE_DEST_FOLDER} )

# Auxiliary files
set( auxFiles  ${CloudCompareProjects_SOURCE_DIR}/CHANGELOG.md bin_other/license.txt bin_other/global_shift_list_template.txt )

if( WIN32 )
	# Export Qt dlls
	install_Qt_Dlls( ${CLOUDCOMPARE_DEST_FOLDER} ${OPTION_SUPPORT_GAMEPADS} )
	install_Qt_ImageFormats( ${CLOUDCOMPARE_DEST_FOLDER} )
	install_Qt5_plugins( ${CLOUDCOMPARE_DEST_FOLDER} )

	# Additional auxiliary file(s)
	file( GLOB batch_list bin_other/*.bat )
	list( APPEND auxFiles ${batch_list} )
endif()

# Install auxiliary files
if( WIN32 OR APPLE )
	foreach( filename ${auxFiles} )
		install_ext( FILES ${filename} ${CLOUDCOMPARE_DEST_FOLDER} )
	endforeach()
else( UNIX )
	foreach( filename ${auxFiles} )
		install_ext( FILES ${filename} share/cloudcompare )
	endforeach()
endif()

# Translation
add_subdirectory( translations )

# in order to ensure that everything else is installed first, put the Mac bundling in its own subdirectory
if( APPLE )
    set_target_properties( ${PROJECT_NAME} PROPERTIES
        INSTALL_RPATH "@executable_path/../Frameworks"
        MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Mac/CloudCompare.plist )

    set( MACOSX_BUNDLE_ICON_FILE cc_icon.icns ) 
    set( MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}" )
    set( MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_VERSION}" )
    set( MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_VERSION}" )
    
    add_subdirectory( Mac )
endif()

## Shaders
# Copy shader dirs into our shadow build directory
file( COPY ${CC_FBO_LIB_SOURCE_DIR}/shaders DESTINATION "${CMAKE_BINARY_DIR}" )
file( COPY ${CMAKE_CURRENT_SOURCE_DIR}/shaders DESTINATION "${CMAKE_BINARY_DIR}" )

# Export common shader files to all install destinations
if( APPLE )	
	install( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.frag DESTINATION ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Shaders/Bilateral )
	install( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.vert DESTINATION ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Shaders/Bilateral )
	install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/shaders/ColorRamp/color_ramp.frag DESTINATION ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Shaders/ColorRamp )
elseif( UNIX )
	install( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.frag DESTINATION share/cloudcompare/shaders/Bilateral )
	install( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.vert DESTINATION share/cloudcompare/shaders/Bilateral )
	install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/shaders/ColorRamp/color_ramp.frag DESTINATION share/cloudcompare/shaders/ColorRamp )
else()
	install_ext( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.frag ${CLOUDCOMPARE_DEST_FOLDER} /shaders/Bilateral )
	install_ext( FILES ${CC_FBO_LIB_SOURCE_DIR}/shaders/Bilateral/bilateral.vert ${CLOUDCOMPARE_DEST_FOLDER} /shaders/Bilateral )
	install_ext( FILES ${CMAKE_CURRENT_SOURCE_DIR}/shaders/ColorRamp/color_ramp.frag ${CLOUDCOMPARE_DEST_FOLDER} /shaders/ColorRamp )
endif()

=== contrib/dxflib-3.17.0/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

# CC custom (external) CMake script for Ribbonsoft's DXF Lib
project( DXF_LIB )

set( CMAKE_AUTOMOC OFF )

file( GLOB header_list src/*.h)
file( GLOB source_list src/*.cpp)

add_library( ${PROJECT_NAME} STATIC ${header_list} ${source_list} )

if (WIN32)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS _CRT_SECURE_NO_DEPRECATE )
endif()

=== libs/CCFbo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/include )

project( CC_FBO_LIB )

file( GLOB header_list include/*.h )
file( GLOB source_list src/*.cpp )

add_library( ${PROJECT_NAME} STATIC ${header_list} ${source_list} )

target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::OpenGL Qt5::OpenGLExtensions )

=== libs/qCC_glWindow/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )
include_directories( ${QCC_DB_LIB_SOURCE_DIR} )
if( MSVC )
   include_directories( ${QCC_DB_LIB_SOURCE_DIR}/msvc )
endif()

project( QCC_GL_LIB )

file( GLOB header_list *.h)
file( GLOB source_list *.cpp)

add_library( ${PROJECT_NAME} STATIC ${header_list} ${source_list} )

target_link_libraries( ${PROJECT_NAME} CC_CORE_LIB )
target_link_libraries( ${PROJECT_NAME} QCC_DB_LIB )
target_link_libraries( ${PROJECT_NAME} CC_FBO_LIB )

# OCULUS support
target_link_OCULUS_SDK( ${PROJECT_NAME} )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui Qt5::Widgets Qt5::OpenGL Qt5::OpenGLExtensions)

# Add custom preprocessor definitions
# set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS )
if (OPTION_GL_QUAD_BUFFER_SUPPORT)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_GL_WINDOW_USE_QWINDOW )
endif()
if (WIN32)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_USE_AS_DLL QCC_DB_USE_AS_DLL )
endif()

=== plugins/example/CMakeLists.txt ===

add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/ExampleGLPlugin )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/ExampleIOPlugin )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/ExamplePlugin )

=== libs/qCC_io/Tests/CMakeLists.txt ===
find_package(Qt5Test REQUIRED)


QT5_ADD_RESOURCES(TestDataResources_SRCS TestData.qrc)

set(TEST_LIBRARIES Qt5::Test Qt5::Core CC_CORE_LIB QCC_DB_LIB QCC_IO_LIB)

if (WIN_32)
    SET(CMAKE_WIN32_EXECUTABLE False)
    set(TEST_LIBRARIES ${TEST_LIBRARIES} Qt5::WinMain)
endif()

if (OPTION_USE_SHAPE_LIB)
    SET(TestShpFilter_SRC TestShpFilter.cpp)
    ADD_EXECUTABLE(TestShpFilter ${TestShpFilter_SRC} ${TestDataResources_SRCS})
    TARGET_LINK_LIBRARIES(TestShpFilter ${TEST_LIBRARIES})
    set_property( TARGET TestShpFilter APPEND PROPERTY COMPILE_DEFINITIONS CC_SHP_SUPPORT )
    ADD_TEST(NAME TestShpFilter COMMAND TestShpFilter)
endif()

=== plugins/core/qAdditionalIO/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

option( INSTALL_QADDITIONAL_IO_PLUGIN "Check to install qAdditionalIO plugin" OFF )

if (INSTALL_QADDITIONAL_IO_PLUGIN)
	project( QADDITIONAL_IO_PLUGIN )

	set( CC_IS_IO_PLUGIN 1 )

	include_directories( src )

	add_subdirectory( src )
	add_subdirectory( ui )

	include( ../../CMakePluginTpl.cmake )
endif()

=== plugins/core/qAnimation/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

option( INSTALL_QANIMATION_PLUGIN "Check to install qAnimation plugin" OFF )

# CloudCompare 'ANIMATION' plugin
if (INSTALL_QANIMATION_PLUGIN)
	option( WITH_FFMPEG_SUPPORT "Check to setup FFMPEG support (to create movies instead of images with qAnimation)" OFF )

	project( QANIMATION_PLUGIN )

	if (WITH_FFMPEG_SUPPORT)
		add_subdirectory( src/QTFFmpegWrapper )
		include_directories( ${QTFFMPEG_LIB_SOURCE_DIR} )
	endif()

	include_directories( src )

	add_subdirectory( src )
	add_subdirectory( ui )

	include( ../../CMakePluginTpl.cmake )

	if (WITH_FFMPEG_SUPPORT)
		target_link_libraries( ${PROJECT_NAME} QTFFMPEG_LIB )
		set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS QFFMPEG_SUPPORT )
	endif()
endif()

=== plugins/core/qBroom/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

option( INSTALL_QBROOM_PLUGIN "Check to install qBroom plugin" OFF )

if (INSTALL_QBROOM_PLUGIN)

	#CloudCompare 'Virtual broom' plugin
	project( QBROOM_PLUGIN )
	
	include_directories( src )
	
	add_subdirectory( src )
	add_subdirectory( ui )
	
	include( ../../CMakePluginTpl.cmake )
	
	include_directories( ${QBROOM_LIB_INCLUDE_DIR} )

endif()

=== debian/changelog ===
cloudcompare (2.10.1-2+rb2) UNRELEASED; urgency=medium

  * update

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 22 Jan 2021 11:02:36 +0800

cloudcompare (2.10.1-2) unstable; urgency=medium

  * Thanks Juhani Numminen for the patch to have
    RPATH absolute. (Closes: #928986)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 27 May 2019 07:36:32 +0200

cloudcompare (2.10.1-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 17 Jan 2019 20:24:25 +0100

=== debian/control ===
Source: cloudcompare
Section: graphics
Priority: optional
Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), cmake, libqt5opengl5-dev, libcgal-dev, libdxflib-dev (>= 2.5.0),
 libglew-dev, libfreenect-dev, libgdal-dev, libgomp1, liblas-c-dev (>= 1.7.0), liblas-dev (>= 1.7.0), libboost-all-dev,
 libjsoncpp-dev, libpdal-dev, libcurl4-gnutls-dev | libcurl4-openssl-dev, libcgal-qt5-dev, libqt5svg5-dev, qttools5-dev-tools, qttools5-dev
Standards-Version: 4.2.1
Homepage: http://www.danielgm.net/cc/

Package: cloudcompare
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3D point cloud and mesh processing software
 This is a 3D point cloud (and triangular mesh) processing software. It has
 been originally designed to perform comparison between two 3D points clouds
 (such as the ones obtained with a laser scanner) or between a point cloud
 and a triangular mesh.
 .
 It relies on a specific octree structure that enables great performances in
 this particular function. It was also meant to deal with huge point clouds
 (typically more than 10 millions points, and up to 120 millions with 2 GB
 of memory)

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

DEBARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DH_VERBOSE=1

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DOPTION_USE_LIBLAS=ON \
		-DOPTION_PDAL_LAS=ON \
		-DCOMPILE_CC_CORE_LIB_WITH_CGAL=ON \
		-DJSON_ROOT_DIR=/usr/include/jsoncpp \
		-DINSTALL_QEDL_PLUGIN=ON \
		-DINSTALL_QHPR_PLUGIN=ON \
		-DINSTALL_QCSF_PLUGIN=ON \
		-DINSTALL_QSRA_PLUGIN=ON \
		-DINSTALL_QSSAO_PLUGIN=ON \
		-DINSTALL_QPCV_PLUGIN=ON \
		-DINSTALL_QBLUR_PLUGIN=ON
#		-DCMAKE_BUILD_TYPE=Release \
#		-DINSTALL_QGMMREG_PLUGIN=ON \
#		-DINSTALL_QANIMATION_PLUGIN=ON \
#		-DPOISSON_RECON_WITH_OPEN_MP=ON \
#		-DINSTALL_QPOISSON_RECON_PLUGIN=ON \
#		-DOPTION_USE_GDAL=ON \
#		-DOPTION_USE_DXF_LIB=ON \
#		-DINSTALL_QPHOTOSCAN_IO_PLUGIN=ON \
#		-DWITH_FFMPEG_SUPPORT=ON \
#		-DFFMPEG_INCLUDE_DIR="/usr/include/$(DEBARCH)" \
#		-DFFMPEG_LIBRARY_DIR="/usr/lib/$(DEBARCH)" \
#		-DOPTION_USE_SHAPE_LIB=ON \
#		-DINSTALL_QM3C2_PLUGIN=ON \
#		-DINSTALL_QBROOM_PLUGIN=true \
#		-DINSTALL_QHOUGH_NORMALS_PLUGIN=true \
#		-DEIGEN_ROOT_DIR=/usr/include/eigen3 \

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/cloudcompare $(DEBARCH)

## cloudcompare 2.10.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,10 +28,8 @@
 # RPATH Linux/Unix: (dynamic) libs are put in a subdir of prefix/lib,
 # since they are only used by qCC/ccViewer
 if( UNIX AND NOT APPLE )
-	if( NOT CMAKE_INSTALL_LIBDIR )
-		set( CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_PREFIX}/lib CACHE PATH "CloudCompare lib dir" )
-	endif( NOT CMAKE_INSTALL_LIBDIR )
-	set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_LIBDIR}/cloudcompare")
+	include( GNUInstallDirs )
+	set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}/cloudcompare")
 endif()
 
 # CCViewer

=== plugins/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project( CloudComparePlugins )

# reset buffers (for MacOS bundle)
set( CLOUDCOMPARE_PLUGINS CACHE INTERNAL "CloudCompare plugin list" )
set( CCVIEWER_PLUGINS CACHE INTERNAL "ccViewer plugin list" )

set( CloudCompare_SOURCE_DIR "${CMAKE_SOURCE_DIR}/qCC" )
set( CloudComparePlugins_SOURCE_DIR "${CMAKE_SOURCE_DIR}/plugins" )

add_subdirectory( core )
add_subdirectory( example )
add_subdirectory( 3rdParty )

=== qCC/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.0)
 
-project( CloudCompare VERSION 2.10.1 )
+project( CloudCompare VERSION 2.10.3 )
 
 include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )
 include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )

=== contrib/shapelib-1.3.0/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project( SHAPELIB )

set( CMAKE_AUTOMOC OFF )

file( GLOB header_list *.h )
file( GLOB source_list *.c )

add_library( ${PROJECT_NAME} STATIC ${header_list} ${source_list} )

=== libs/qCC_db/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )

project( QCC_DB_LIB )

file( GLOB header_list *.h)
file( GLOB source_list *.cpp)

add_library( ${PROJECT_NAME} SHARED ${header_list} ${source_list} )

target_link_libraries( ${PROJECT_NAME} CC_CORE_LIB )
target_link_libraries( ${PROJECT_NAME} CC_FBO_LIB )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui Qt5::Widgets Qt5::OpenGL)

# Add custom preprocessor definitions
if (WIN32)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_USE_AS_DLL QCC_DB_USE_AS_DLL )
endif()

# install (shared) lib to specified destinations
if( WIN32 OR APPLE )
	foreach( dest ${INSTALL_DESTINATIONS} )
		install_shared( ${PROJECT_NAME} ${dest} 1 )
	endforeach()
else()
	install_shared( ${PROJECT_NAME} ${CMAKE_INSTALL_LIBDIR}/cloudcompare 0 ) #default destination: /usr/lib
endif()

=== libs/qCC_io/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
include_directories( ${CC_CORE_LIB_SOURCE_DIR}/include )
include_directories( ${CC_FBO_LIB_SOURCE_DIR}/include )
include_directories( ${QCC_DB_LIB_SOURCE_DIR} )
if( MSVC )
   include_directories( ${QCC_DB_LIB_SOURCE_DIR}/msvc )
endif()
include_directories( ${CMAKE_CURRENT_BINARY_DIR} )

project( QCC_IO_LIB )

file( GLOB header_list *.h)
file( GLOB source_list *.cpp *.c)
file( GLOB ui_list ui_templates/*.ui )

# PDMS support
if( ${OPTION_SUPPORT_MAC_PDMS_FORMAT} )
	file( GLOB PDMS_header_list PDMS/*.h )
	file( GLOB PDMS_source_list PDMS/*.cpp )
	list( APPEND header_list ${PDMS_header_list} )
	list( APPEND source_list ${PDMS_source_list} )
endif()

qt5_wrap_ui( generated_ui_list ${ui_list} )
add_library( ${PROJECT_NAME} SHARED ${header_list} ${source_list} ${generated_ui_list} )

target_link_libraries( ${PROJECT_NAME} CC_CORE_LIB )
target_link_libraries( ${PROJECT_NAME} CC_FBO_LIB )
target_link_libraries( ${PROJECT_NAME} QCC_DB_LIB )

# Qt
target_link_libraries(${PROJECT_NAME} Qt5::Core)	

# contrib. libraries support
target_link_contrib( ${PROJECT_NAME} )

# Add custom preprocessor definitions
if (WIN32)
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CC_USE_AS_DLL QCC_DB_USE_AS_DLL QCC_IO_USE_AS_DLL )
elseif( APPLE )
	set_target_properties( ${PROJECT_NAME} PROPERTIES
		INSTALL_RPATH "." )
endif()

# install (shared) lib to specified destinations
if( WIN32 OR APPLE )
	foreach( dest ${INSTALL_DESTINATIONS} )
		install_shared( ${PROJECT_NAME} ${dest} 1 )
	endforeach()
else()
	install_shared( ${PROJECT_NAME} ${CMAKE_INSTALL_LIBDIR}/cloudcompare 0 ) #default destination: /usr/lib
endif()

if(BUILD_TESTING)
	add_subdirectory(Tests)
endif()

=== libs/qcustomplot/CMakeLists.txt ===
PROJECT(qcustomplot)

set( QCUSTOMPLOT_HEADERS qcustomplot.h )
set( QCUSTOMPLOT_SOURCES qcustomplot.cpp )

add_library(${PROJECT_NAME} STATIC ${QCUSTOMPLOT_HEADERS} ${QCUSTOMPLOT_SOURCES} )

=== plugins/3rdParty/CMakeLists.txt ===
# Auto add all subdirectories
file( GLOB subdirectories * )

foreach( dir ${subdirectories} )
    if( IS_DIRECTORY ${dir} )
		# in case the user generates the BUILD project in the same folder as the sources!
		if ( NOT ${dir} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR}/CMakeFiles )
			message( STATUS "Auto-add 3rd party plugin: " ${dir} )
			add_subdirectory ( ${dir} )
		endif()
	endif()
endforeach()

=== plugins/core/CMakeLists.txt ===

add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qAdditionalIO )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qAnimation )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qBroom )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qCanupo )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qCompass )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qCork )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qCSF )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qCSVMatrixIO )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qEDL )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qFacets )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qHoughNormals )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qHPR )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qLAS_FWF )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qM3C2 )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qPCL )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qPCV )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qPhotoscanIO )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qPoissonRecon )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qRANSAC_SD )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qSRA )
add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/qSSAO )

=== qCC/Mac/CMakeLists.txt ===
# Put together our App bundle on Mac OS X
if( APPLE )
   # this will install all the Qt libs and the necessary plugins
   install( CODE "execute_process( COMMAND \"${MACDEPLOYQT}\" \"${CLOUDCOMPARE_MAC_BASE_DIR}\" -verbose=1 )" COMPONENT Runtime )
   
   # install icons
   install( FILES ../images/icon/cc_icon.icns DESTINATION ${CLOUDCOMPARE_MAC_BASE_DIR}/Contents/Resources COMPONENT Runtime )   
   
   # remove any dev-machine specific lib paths
   install( CODE "execute_process( COMMAND \"${CMAKE_SOURCE_DIR}/scripts/mac/fix_libs.sh\"
       \"${CLOUDCOMPARE_MAC_FRAMEWORK_DIR}\" )" COMPONENT Runtime )
endif( APPLE )

=== plugins/core/qCSF/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

option( INSTALL_QCSF_PLUGIN "Check to install qCSF plugin" OFF )

if (INSTALL_QCSF_PLUGIN)

	#CloudCompare 'CSF' plugin
	project( QCSF_PLUGIN )

	include_directories( src )
	
	add_subdirectory( src )
	add_subdirectory( ui )
	
	include( ../../CMakePluginTpl.cmake )

endif()

=== plugins/core/qCanupo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

option( INSTALL_QCANUPO_PLUGIN "Check to install qCanupo plugin" OFF )

if (INSTALL_QCANUPO_PLUGIN)

#CloudCompare 'Canupo' plugin
project( QCANUPO_PLUGIN_DLL )

set( DLIB_ROOT "" CACHE PATH "DLib library root directory" )
if ( NOT DLIB_ROOT )
	message( SEND_ERROR "No DLib library root specified (DLIB_ROOT)" )
else()
	include_directories( ${DLIB_ROOT} )
endif()

include( ../../CMakePluginTpl.cmake )

option( COMPILE_QCANUPO_WITH_PRIVATE_PARTS "Check to compile qCanupo plugin with private methods (CNRS/UEB only)" OFF )
if ( COMPILE_QCANUPO_WITH_PRIVATE_PARTS )
	set_property( TARGET ${PROJECT_NAME} APPEND PROPERTY COMPILE_DEFINITIONS COMPILE_PRIVATE_CANUPO )
endif()

endif()

=== debian/changelog ===
cloudcompare (2.10.3-4) unstable; urgency=medium

  * d/rules: -DCOMPILE_CC_CORE_LIB_WITH_CGAL=OFF (Closes: #947474)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 08 Jan 2020 10:28:03 +0100

cloudcompare (2.10.3-3) unstable; urgency=medium

  * Also build animation, broom, gmmreg, and m3c2 plugins.
  * debian/control: add libavcodec-dev, libavformat-dev, libswscale-dev,
    liblaszip-dev to build-depends.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 02 Sep 2019 13:23:19 +0200

cloudcompare (2.10.3-2) unstable; urgency=medium

  * Drop liblas build dependency, will be removed from Debian.
    Thanks for the patch, Bas Couwenberg. (Closes: #932020)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 28 Jul 2019 21:05:50 +0200

cloudcompare (2.10.3-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 17 Jun 2019 10:02:44 +0200

cloudcompare (2.10.2-2) experimental; urgency=medium

  * debian/control: versioned libpdal-dev for LAZ file support.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 06 Jun 2019 13:00:24 +0200

cloudcompare (2.10.2-1) experimental; urgency=medium

  * New upstream version.
  * debian/watch: added.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 05 Mar 2019 20:43:32 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
 Build-Depends: debhelper (>= 11), cmake, libqt5opengl5-dev, libcgal-dev, libdxflib-dev (>= 2.5.0),
- libglew-dev, libfreenect-dev, libgdal-dev, libgomp1, liblas-c-dev (>= 1.7.0), liblas-dev (>= 1.7.0), libboost-all-dev,
- libjsoncpp-dev, libpdal-dev, libcurl4-gnutls-dev | libcurl4-openssl-dev, libcgal-qt5-dev, libqt5svg5-dev, qttools5-dev-tools, qttools5-dev
+ libglew-dev, libfreenect-dev, libgdal-dev, libgomp1, libboost-all-dev, libavcodec-dev, libavformat-dev, libswscale-dev, liblaszip-dev,
+ libjsoncpp-dev, libpdal-dev (>= 1.9.1+ds-1~exp2), libcurl4-gnutls-dev | libcurl4-openssl-dev, libcgal-qt5-dev, libqt5svg5-dev, qttools5-dev-tools, qttools5-dev
 Standards-Version: 4.2.1
 Homepage: http://www.danielgm.net/cc/

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

DEBARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DH_VERBOSE=1

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

override_dh_auto_clean:
	cp debian/ccApplicationBase.cpp common/
	dh_clean

override_dh_auto_configure:
	$(shell sed -i s,lib/cloudcompare/plugins,lib/$(DEBARCH)/cloudcompare/plugins,g common/ccApplicationBase.cpp)
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DOPTION_USE_LIBLAS=ON \
		-DOPTION_PDAL_LAS=ON \
		-DCOMPILE_CC_CORE_LIB_WITH_CGAL=OFF \
		-DJSON_ROOT_DIR=/usr/include/jsoncpp \
		-DINSTALL_QEDL_PLUGIN=ON \
		-DINSTALL_QHPR_PLUGIN=ON \
		-DINSTALL_QCSF_PLUGIN=ON \
		-DINSTALL_QSRA_PLUGIN=ON \
		-DINSTALL_QSSAO_PLUGIN=ON \
		-DINSTALL_QPCV_PLUGIN=ON \
		-DINSTALL_QANIMATION_PLUGIN=ON \
		-DINSTALL_QM3C2_PLUGIN=ON \
		-DINSTALL_QBROOM_PLUGIN=true \
		-DINSTALL_QGMMREG_PLUGIN=ON \
		-DWITH_FFMPEG_SUPPORT=ON \
		-DFFMPEG_INCLUDE_DIR="/usr/include/$(DEBARCH)" \
		-DFFMPEG_LIBRARY_DIR="/usr/lib/$(DEBARCH)" \
		-DINSTALL_QBLUR_PLUGIN=ON
#		-DCMAKE_BUILD_TYPE=Release \
#		-DINSTALL_QHOUGH_NORMALS_PLUGIN=true \
#		-DINSTALL_QPOISSON_RECON_PLUGIN=ON \
#		-DPOISSON_RECON_WITH_OPEN_MP=ON \
#		-DOPTION_USE_GDAL=ON \
#		-DOPTION_USE_DXF_LIB=ON \
#		-DINSTALL_QPHOTOSCAN_IO_PLUGIN=ON \
#		-DOPTION_USE_SHAPE_LIB=ON \
#		-DEIGEN_ROOT_DIR=/usr/include/eigen3 \

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/cloudcompare $(DEBARCH)
